<?php
Class Chat extends Aj {
    function upload_media() {
        global $db, $_UPLOAD, $_DS;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        if (!isset($_FILES) && empty($_FILES)) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $error = false;
        $to    = '';
        if (isset($_POST[ 'to' ]) && !empty($_POST[ 'to' ])) {
            $to = (int) str_replace('*-*!*~*#*$*%*', '', strrev(base64_decode($_POST[ 'to' ])));
        }
        if (!is_numeric($to)) {
            return array(
                'status' => 200,
                'message' => __('Hack attempt.')
            );
        }
        $file = '';
        if (!file_exists($_UPLOAD . 'chat' . $_DS . date('Y'))) {
            mkdir($_UPLOAD . 'chat' . $_DS . date('Y'), 0777, true);
        }
        if (!file_exists($_UPLOAD . 'chat' . $_DS . date('Y') . $_DS . date('m'))) {
            mkdir($_UPLOAD . 'chat' . $_DS . date('Y') . $_DS . date('m'), 0777, true);
        }
        $dir = $_UPLOAD . 'chat' . $_DS . date('Y') . $_DS . date('m');
        foreach ($_FILES as $file) {
            $ext      = pathinfo($file[ 'name' ], PATHINFO_EXTENSION);
            $key      = GenerateKey();
            $filename = $dir . $_DS . $key . '.' . $ext;
            if (move_uploaded_file($file[ 'tmp_name' ], $filename)) {
                $thumbfile = $dir . $_DS . $key . '_m.' . $ext;
                $thumbnail = new ImageThumbnail($filename);
                $thumbnail->save($thumbfile);
                @unlink($filename);
                if (is_file($thumbfile)) {
                    UploadToS3($thumbfile, array(
                        'amazon' => 0
                    ));
                }
                $msg                 = array();
                $msg[ 'from' ]       = self::ActiveUser()->id;
                $msg[ 'to' ]         = $to;
                $msg[ 'media' ]      = 'upload/chat/' . date('Y') . '/' . date('m') . '/' . $key . '_m.' . $ext;
                $msg[ 'seen' ]       = 0;
                $msg[ 'created_at' ] = date('Y-m-d H:i:s');
                $saved               = $db->insert('messages', $msg);
                if ($saved) {
                    $file = GetMedia('upload/chat/' . date('Y') . '/' . date('m') . '/' . $key . '_m.' . $ext);
                }
            } else {
                $error = true;
            }
        }
        if ($error) {
            return array(
                'status' => 403
            );
        } else {
            return array(
                'status' => 200,
                'file' => $file
            );
        }
    }
    function open_private_conversation() {
        global $db, $config;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $from = 0;
        if (isset($_POST[ 'from' ]) && is_numeric($_POST[ 'from' ])) {
            $from = (int) Secure($_POST[ 'from' ]);
        } else {
            return array(
                'status' => 400,
                'message' => __('No from id found.')
            );
        }
        if (self::ActiveUser()->is_pro == '0') {
            if (GetNonProMaxUserChatsPerDay(self::ActiveUser()->id) > $config->not_pro_chat_limit_daily - 1) {
                if (isNonProCanChatWith(self::ActiveUser()->id, (int) $from) === false) {
                    return array(
                        'status' => 200,
                        'message' => __('please recharge your credits.'),
                        'mode' => 'credits'
                    );
                }
            }
        }
        $_user = LoadEndPointResource('users');
        if ($_user) {
            $user_from            = $_user->get_user_profile($from);
            $conversationMessages = generate_chat_messages_convirsation((int) self::ActiveUser()->id, (int) $from, 0, true);
            return array(
                'status' => 200,
                'from' => self::ActiveUser()->id,
                'self::ActiveUser()->id' => self::ActiveUser()->id,
                'to' => $user_from,
                'messages' => $conversationMessages,
                'mode' => 'chat',
                'receiver' => base64_encode(strrev('*-*!*~*#*$*%*' . $user_from->id . '*-*!*~*#*$*%*'))
            );
        } else {
            return false;
        }
    }
    function open_conversation() {
        global $db;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $from = 0;
        if (isset($_POST[ 'from' ]) && is_numeric($_POST[ 'from' ])) {
            $from = (int) Secure($_POST[ 'from' ]);
        } else {
            return array(
                'status' => 400,
                'message' => __('No from id found.')
            );
        }
        $_user = LoadEndPointResource('users');
        if ($_user) {
            $user_from            = $_user->get_user_profile($from);
            $conversationMessages = generate_chat_messages_convirsation((int) self::ActiveUser()->id, (int) $from, 0, true);
            return array(
                'status' => 200,
                'from' => self::ActiveUser()->id,
                'to' => $user_from,
                'messages' => $conversationMessages,
                'receiver' => base64_encode(strrev('*-*!*~*#*$*%*' . $user_from->id . '*-*!*~*#*$*%*'))
            );
        } else {
            return false;
        }
    }
    function chat_change_online() {
        global $db;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $updated = $db->where('id', self::ActiveUser()->id)->update('users', array(
            'lastseen' => time(),
            'online' => ((self::ActiveUser()->online == 1) ? 0 : 1)
        ));
        if ($updated) {
            $_SESSION[ 'userEdited' ] = true;
            return array(
                'status' => 200
            );
        } else {
            return array(
                'status' => 400
            );
        }
    }
    function record_user_lastseen() {
        global $db;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        if (self::ActiveUser()->online == 1) {
            $updated = $db->where('id', self::ActiveUser()->id)->update('users', array(
                'lastseen' => time()
            ));
            if ($updated) {
                $_SESSION[ 'userEdited' ] = true;
                return array(
                    'status' => 200
                );
            } else {
                return array(
                    'status' => 400
                );
            }
        } else {
            return array(
                'status' => 200
            );
        }
    }
    function mark_all_messages_as_read() {
        global $db;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $updated = $db->where('`to`', self::ActiveUser()->id)->where('seen', 0)->update('messages', array(
            'seen' => time()
        ));
        if ($updated) {
            return array(
                'status' => 200
            );
        } else {
            return array(
                'status' => 204
            );
        }
    }
    function search() {
        global $db, $config, $_BASEPATH, $_DS;
        $site_url   = $config->uri;
        $theme_url  = $config->uri . '/themes/' . $config->theme . '/';
        $theme_path = $_BASEPATH . 'themes' . $_DS . $config->theme . $_DS;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $is_online = 0;
        if (isset($_POST[ 'is_online' ])) {
            if ($_POST[ 'is_online' ] == 'true') {
                $is_online = 1;
            } else {
                $is_online = 0;
            }
        }
        if (isset($_POST[ 'search_text' ]) && !empty($_POST[ 'search_text' ])) {
            $search_text = Secure($_POST[ 'search_text' ]);
        } else {
            return array(
                'status' => 200,
                'message' => ''
            );
        }
        $conversationHtml = '';
        $_msg             = LoadEndPointResource('messages');
        if ($_msg) {
            $conversations = $_msg->searchChat($search_text, $is_online);
            if (count($conversations) > 0) {
                foreach ($conversations as $key => $conversation) {
                    if (file_exists($theme_path . 'main' . $_DS . 'conversation-list.php')) {
                        ob_start();
                        require($theme_path . 'main' . $_DS . 'conversation-searchlist.php');
                        $conversationHtml .= ob_get_contents();
                        ob_end_clean();
                    }
                }
            }
            return array(
                'status' => 200,
                'message' => $conversationHtml
            );
        } else {
            return array(
                'status' => 204
            );
        }
    }
    function send_message() {
        global $db, $config;
        $html_return = '';
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $to = '';
        if (isset($_POST[ 'to' ]) && !empty($_POST[ 'to' ])) {
            $to = (int) str_replace('*-*!*~*#*$*%*', '', strrev(base64_decode($_POST[ 'to' ])));
        }
        if (!is_numeric($to)) {
            return array(
                'status' => 200,
                'message' => __('Hack attempt.')
            );
        }
        if (self::ActiveUser()->is_pro == '0') {
            if (GetNonProMaxUserChatsPerDay(self::ActiveUser()->id) > $config->not_pro_chat_limit_daily - 1) {
                if (isNonProCanChatWith(self::ActiveUser()->id, (int) $to) === false) {
                    return array(
                        'status' => 200,
                        'message' => __('please recharge your credits.')
                    );
                }
            }
        }
        $text    = NULL;
        $sticker = NULL;
        if (isset($_POST[ 'text' ]) && !empty($_POST[ 'text' ])) {
            $text = Secure($_POST[ 'text' ]);
        }
        if (isset($_POST[ 'sticker' ]) && !empty($_POST[ 'sticker' ])) {
            $sticker = Secure($_POST[ 'sticker' ]);
        }
        if ($text === NULL && $sticker === NULL) {
            return array(
                'status' => 200,
                'message' => ''
            );
        }
        if ($text == '' && $sticker == '') {
            return array(
                'status' => 200,
                'message' => ''
            );
        }
        if ((int) $to === (int) self::ActiveUser()->id) {
            return array(
                'status' => 200,
                'message' => ''
            );
        }
        if ($to > 0) {
            if (isUserInBlockList($to)) {
                return array(
                    'status' => 400,
                    'blacklist' => true,
                    'message' => ''
                );
            }
            if ($sticker > 0) {
                $text = NULL;
            }
            if ($text !== '' && $sticker === NULL) {
                $sticker = NULL;
            }
            $saved = $db->insert('messages', array(
                'from' => (int) self::ActiveUser()->id,
                'to' => (int) $to,
                'text' => $text,
                'sticker' => $sticker,
                'seen' => 0,
                'created_at' => date('Y-m-d H:i:s')
            ));
            if ($saved) {
                $_msg = LoadEndPointResource('messages');
                if ($_msg) {
                    $_msg->createNewConversation((int) $to);
                }
                return array(
                    'status' => 200,
                    'message' => __('Message sent'),
                    'to' => $to,
                    'msg' => $saved
                );
            }
        }
    }
    function get_stickers() {
        global $db, $config;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $limit_stickers = 0;
        if (self::ActiveUser()->is_pro == '0') {
            $limit_stickers = $config->not_pro_chat_stickers_limit - 1;
        }
        if (self::ActiveUser()->is_buy_stickers == '1') {
            $limit_stickers = 0;
        }
        $stickers_html = '';
        $stickers      = $db->objectBuilder()->orderBy('id', 'desc')->get('stickers', null, array(
            'id',
            'file'
        ));
        $i             = 0;
        foreach ($stickers as $key => $value) {
            if ($limit_stickers > 0) {
                if ($i > $limit_stickers) {
                    continue;
                }
            }
            $stickers_html .= '<img src="' . GetMedia($value->file) . '" data-id="' . $value->id . '" class="stiker_chat">';
            $i++;
        }
        if ($limit_stickers > 0) {
            $stickers_html .= '<hr><p>' . __('Wanna get more? get premium! OR get new stickers for') . ' ' . $config->not_pro_chat_stickers_credit . ' ' . __('credits') . '</p>';
            if (self::ActiveUser()->balance >= $config->not_pro_chat_stickers_credit) {
                $stickers_html .= '<div class="dt_stk_buy_btn"><a href="' . $config->uri . '/pro" data-ajax="/pro" class="btn btn-flat waves-effect prem">' . __('Get premium') . '</a>';
                $stickers_html .= '<button data-userid="' . self::ActiveUser()->id . '" id="btn_buystikcers" class="btn btn-flat waves-effect stck_by">' . __('Buy Now!') . '</button></div>';
            } else {
                $stickers_html .= '<div class="dt_stk_buy_btn"><a href="' . $config->uri . '/pro" data-ajax="/pro" class="btn btn-flat waves-effect prem">' . __('Get premium') . '</a>';
                $stickers_html .= '<a href="' . $config->uri . '/credit" data-ajax="/credit" class="btn btn-flat waves-effect stck_by">' . __('Buy Credits') . '</a></div>';
            }
        }
        return array(
            'status' => 200,
            'stickers' => $stickers_html
        );
    }
    function delete_messages() {
        global $db;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $from = self::ActiveUser()->id;
        $to   = '';
        if (isset($_POST[ 'to' ]) && !empty($_POST[ 'to' ])) {
            $to = (int) Secure(str_replace('*-*!*~*#*$*%*', '', strrev(base64_decode($_POST[ 'to' ]))));
        }
        if (!is_numeric($to)) {
            return array(
                'status' => 200,
                'message' => __('Hack attempt.')
            );
        }
        $db->where('`to`', $to)->where('`from`', $from)->update('messages', array(
            'from_delete' => '1'
        ));
        $db->where('`to`', $from)->where('`from`', $to)->update('messages', array(
            'to_delete' => '1'
        ));
        $db->where('sender_id', $to)->where('receiver_id', $from)->update('conversations', array(
            'from_delete' => '1'
        ));
        $db->where('sender_id', $from)->where('receiver_id', $to)->update('conversations', array(
            'to_delete' => '1'
        ));
        $db->where('from_delete', '1')->where('to_delete', '1')->delete('messages');
        $db->where('from_delete', '1')->where('to_delete', '1')->delete('conversations');
        return array(
            'status' => 200
        );
    }
    function get_conversation_list() {
        global $db, $config, $_BASEPATH, $_DS;
        $site_url   = $config->uri;
        $theme_url  = $config->uri . '/themes/' . $config->theme . '/';
        $theme_path = $_BASEPATH . 'themes' . $_DS . $config->theme . $_DS;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $data               = array(
            'status' => 200
        );
        $messages           = LoadEndPointResource('messages');
        $conversations      = ToObject($messages->getConversationList());
        $OnlineUsers        = 0;
        $conversations_html = '';
        $mode               = route(4);
        foreach ($conversations as $key => $msg) {
            if((int)abs(((strtotime(date('Y-m-d H:i:s')) - $msg->user->lastseen))) < 60 && (int)$msg->user->online == 1){
                $OnlineUsers++;
            }
        }
        if (!empty($conversations)) {
            if (count((array) $conversations) > 0) {
                $is_online1 = 0;
                $is_online2 = 0;
                foreach ($conversations as $key => $conversation) {
                    if((int)abs(((strtotime(date('Y-m-d H:i:s')) - $conversation->user->lastseen))) < 60 && (int)$conversation->user->online == 1){
                        $is_online1 = 1;
                    } else {
                        $is_online1 = 0;
                    }
                    if (file_exists($theme_path . 'main' . $_DS . 'conversation-list.php')) {
                        ob_start();
                        require($theme_path . 'main' . $_DS . 'conversation-list.php');
                        $conversations_html .= ob_get_contents();
                        ob_end_clean();
                    }
                    unset($conversations->{$key});
                }
            }
        }
        $db->where('id', self::ActiveUser()->id)->update('users', array(
            'lastseen' => time()
        ));
        $_SESSION[ 'userEdited' ] = true;
        $data[ 'conversations' ]  = $conversations_html;
        $data[ 'OnlineUsers' ]    = $OnlineUsers;
        return $data;
    }
    function get_chat_conversation() {
        global $db;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $data    = array(
            'status' => 200,
            'conversations' => ''
        );
        $from    = (int) route(4);
        $lastmsg = (int) route(5);
        if ($from > 0) {
            $lastseenid              = $db->objectBuilder()->where('`from`', (int) auth()->id)->where('`to`', (int) $from)->where('seen', '0', '>')->orderBy('id', 'DESC')->getValue('messages', 'id');
            $conversationMessages    = generate_chat_messages_convirsation((int) auth()->id, (int) $from, 0, false, (($lastmsg > 0) ? $lastmsg : 0));
            $data[ 'conversations' ] = $conversationMessages;
            $data[ 'from' ]          = $from;
            $data[ 'to' ]            = auth()->id;
            $data[ 'lastseenid' ]    = $lastseenid;
        }
        return $data;
    }
    function createNewConversation() {
        global $db;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $receiver_id = '';
        if (isset($_GET[ 'receiver_id' ]) && !empty($_GET[ 'receiver_id' ])) {
            $receiver_id = (int) Secure($_GET[ 'receiver_id' ]);
        }
        if ($receiver_id == '') {
            return array(
                'status' => 400,
                'message' => __('Bad Request')
            );
        }
        $_msg = LoadEndPointResource('messages');
        if ($_msg) {
            $saved = $_msg->createNewConversation($receiver_id);
            if ($saved) {
                return array(
                    'status' => 200,
                    'message' => ''
                );
            } else {
                return array(
                    'status' => 400,
                    'message' => ''
                );
            }
        } else {
            return array(
                'status' => 400,
                'message' => ''
            );
        }
    }
    function get_prev_messages() {
        global $db;
        global $db;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $data  = array(
            'status' => 200,
            'conversations' => ''
        );
        $_from = route(4);
        $from  = 0;
        if (!empty($_from)) {
            $from = (int) Secure(str_replace('*-*!*~*#*$*%*', '', strrev(base64_decode($_from))));
        }
        if (!is_numeric($from)) {
            return array(
                'status' => 200,
                'message' => __('Hack attempt.')
            );
        }
        $lastmsg = (int) route(5);
        if ($from > 0) {
            $lastseenid              = $db->objectBuilder()->where('`from`', (int) auth()->id)->where('`to`', (int) $from)->where('seen', '0', '>')->orderBy('id', 'DESC')->getValue('messages', 'id');
            $conversationMessages    = generate_chat_messages_convirsation((int) auth()->id, (int) $from, 0, false, (($lastmsg > 0) ? $lastmsg : 0), true);
            $data[ 'conversations' ] = $conversationMessages;
            $data[ 'from' ]          = $from;
            $data[ 'to' ]            = auth()->id;
            $data[ 'lastseenid' ]    = $lastseenid;
        }
        return $data;
    }
    function buystickers() {
        global $db, $config;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $_cost  = 0;
        $userid = 0;
        $error  = '';
        if (isset($_POST[ 'uid' ]) && !empty($_POST[ 'uid' ])) {
            $userid = Secure($_POST[ 'uid' ]);
        }
        if ($userid == 0) {
            $error = '<p>• ' . __('No user ID found.') . '</p>';
        }
        $_cost = $config->not_pro_chat_stickers_credit;
        if (self::ActiveUser()->balance >= $_cost) {
        } else {
            $error = '<p>• ' . __('No credit available.') . '</p>';
        }
        if ($error == '') {
            $saved = $db->where('id', self::ActiveUser()->id)->update('users', array(
                'is_buy_stickers' => '1',
                'balance' => $db->dec($_cost)
            ));
            if ($saved) {
                $_SESSION[ 'userEdited' ] = true;
                return array(
                    'status' => 200,
                    'current_credit' => self::ActiveUser()->balance - $_cost,
                    'message' => __('User buy stickers successfully.')
                );
            } else {
                $error = '<p>• Error while buy stickers.';
            }
        }
        if ($error !== '') {
            return array(
                'status' => 400,
                'message' => __('Error while save like.')
            );
        }
    }
    function buymore_chat_credit() {
        global $db, $config;
        if (self::ActiveUser() == NULL) {
            return array(
                'status' => 403,
                'message' => __('Forbidden')
            );
        }
        $_cost    = 0;
        $userid   = 0;
        $chat_uid = 0;
        $error    = '';
        if (isset($_POST[ 'uid' ]) && !empty($_POST[ 'uid' ])) {
            $userid = Secure($_POST[ 'uid' ]);
        }
        if ($userid == 0) {
            $error = '<p>• ' . __('No user ID found.') . '</p>';
        }
        if (isset($_POST[ 'chat_uid' ]) && !empty($_POST[ 'chat_uid' ])) {
            $chat_uid = Secure($_POST[ 'chat_uid' ]);
        }
        if ($chat_uid == 0) {
            $error = '<p>• ' . __('No chat user ID found.') . '</p>';
        }
        $_cost = $config->not_pro_chat_credit;
        if (self::ActiveUser()->balance >= $_cost) {
        } else {
            $error = '<p>• ' . __('No credit available.') . '</p>';
        }
        if ($error == '') {
            $saved = $db->insert('user_chat_buy', array(
                'user_id' => self::ActiveUser()->id,
                'chat_user_id' => $chat_uid,
                'created_at' => date('Y-m-d H:i:s')
            ));
            if ($saved) {
                $db->where('id', self::ActiveUser()->id)->update('users', array(
                    'balance' => $db->dec($_cost)
                ));
                $_SESSION[ 'userEdited' ] = true;
                return array(
                    'status' => 200,
                    'current_credit' => self::ActiveUser()->balance - $_cost,
                    'message' => __('User buy new chat successfully.')
                );
            } else {
                $error = '<p>• ' . __('Error while buy more chat credit.') . '</p>';
            }
        }
        if ($error !== '') {
            return array(
                'status' => 400,
                'message' => __('Error while buy more chat credit.')
            );
        }
    }
}